#ifndef APP_SADIE_H
#define APP_SADIE_H 1

#ifdef __cplusplus
extern "C" {
#endif

#include "sadie.h"

extern void *app_data;            /* Opaque application-specific data pointer */

/* Progress meter callback function pointers */
extern app_progmeter_creator_t app_progmeter_create;
extern app_progmeter_updator_t app_progmeter_update;
extern app_progmeter_destructor_t app_progmeter_destroy;

/* Invocation macros (checking for NULL pointers and hiding application data) */
#define APP_PROGMETER_CREATE(pmname) ((app_progmeter_create) \
    ? (*app_progmeter_create)((pmname),app_data) : 0)
#define APP_PROGMETER_UPDATE(mid,val) ((app_progmeter_update) \
    ? (*app_progmeter_update)((mid),(val),app_data) : 0)
#define APP_PROGMETER_DESTROY(mid) ((app_progmeter_destroy) \
    ? (*app_progmeter_destroy)((mid),app_data) : 0)

#ifdef __cplusplus
}
#endif

#endif /* !defined APP_SADIE_H */

