#if defined SADIE_IPT
#include "IPT.h"
#else
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include "sadie.h"
#ifdef SADIE_LIB
#include "app_sadie.h"
#endif /* defined SADIE_LIB */
#endif /* defined SADIE_IPT */

char *functions[T_END][2]  =  { { "",           ""              },
                                { "BILTOBSQ",   "biltobsq.c"    },
                                { "BITPLANE",   "bitplane.c"    },
                                { "BSQTOBIL",   "bsqtobil.c"    },
                                { "CHECKER",    "checker.c"     },
                                { "CHECKIMG",   "control.c"     },
                                { "CHIRP",      "chirp.c"       },
                                { "CLUSTER",    "cluster.c"     },
                                { "COM2REAL",   "com2real.c"    },
                                { "COMBINE",    "combine.c"     },
                                { "COMPARE",    "compare.c"     },
                                { "CONTNORM",   "contnorm.c"    },
                                { "CONTOUR",    "contour.c"     },
                                { "COVAR",      "covar.c"       },
                                { "CSPLINE",    "geomwarp.c"    },
                                { "DECORSTR",   "decorstr.c"    },
                                { "DESTRIPE",   "destripe.c"    },
                                { "DISK2IMG",   "disk2img.c"    },
                                { "DUPL",       "dupl.c"        },
                                { "EDGE",       "edge.c"        },
                                { "EIGEN",      "eigen.c"       },
                                { "EXPAND",     "expand.c"      },
                                { "FCONVL",     "fconvl.c"      },
                                { "FFT1D",      "fft2d.c"       },
                                { "FFT2D",      "fft2d.c"       },
                                { "FHT1D",      "fht2d.c"       },
                                { "FHT2D",      "fht2d.c"       },
                                { "FILTER",     "filter.c"      },
                                { "FINI",       "control.c"     },
                                { "FLTBOX",     "filter.c"      },
                                { "FLTCONE",    "filter.c"      },
                                { "FLTCYL",     "filter.c"      },
                                { "FLTEXP",     "filter.c"      },
                                { "FLTGAUSS",   "filter.c"      },
                                { "FUNCTION",   "function.c"    },
                                { "GEOMCOEF",   "geomcoef.c"    },
                                { "GEOMWARP",   "geomwarp.c"    },
                                { "GETMEM",     "control.c"     },
                                { "GRADIENT",   "gradient.c"    },
                                { "GRAYSCAL",   "grayscal.c"    },
                                { "HELP",       "control.c"     },
                                { "HISTEQ",     "histeq.c"      },
                                { "HISTOGRM",   "histogrm.c"    },
                                { "HMOSAIC",    "hmosaic.c"     },
                                { "HSVTORGB",   "hsvtorgb.c"    },
                                { "IMG2DISK",   "img2disk.c"    },
                                { "IMG2EPSF",   "img2epsf.c"    },
                                { "IMG2TEXT",   "img2text.c"    },
                                { "IMG2TIFF",   "img2tiff.c"    },
                                { "IMGINFO",    "imginfo.c"     },
                                { "IMPORT",     "import.c"      },
                                { "INIT",       "control.c"     },
                                { "INSERT",     "insert.c"      },
                                { "INVERT",     "invert.c"      },
                                { "JPEG2IMG",   "jpeg2img.c"    },
                                { "LABEL",      "label.c"       },
                                { "LVLSLICE",   "lvlslice.c"    },
                                { "MAIN",       ""              },
                                { "MATCH",      "match.c"       },
                                { "MAXLIKE",    "maxlike.c"     },
                                { "MEDIAN",     "median.c"      },
                                { "MESSAGE",    "control.c"     },
                                { "MINDIST",    "mindist.c"     },
                                { "MOSAIC",     "mosaic.c"      },
                                { "PACK",       "control.c"     },
                                { "PCT",        "pct.c"         },
                                { "PLOT",       "plot.c"        },
                                { "PROGRESS",   "control.c"     },
                                { "PSPECT",     "pspect.c"      },
                                { "PSPECT1D",   "pspect.c"      },
                                { "RANDOM",     "random.c"      },
                                { "RANDOM3D",   "random.c"      },
                                { "RANGE",      "control.c"     },
                                { "REAL2COM",   "real2com.c"    },
                                { "REFINE",     "refine.c"      },
                                { "RELIEF",     "relief.c"      },
                                { "RELIMG",     "control.c"     },
                                { "RELMEM",     "control.c"     },
                                { "RESAMPL",    "resampl.c"     },
                                { "RGBTOHSV",   "rgbtohsv.c"    },
                                { "RMSDIFF",    "rmsdiff.c"     },
                                { "ROISTATS",   "roistats.c"    },
                                { "ROTATE",     "rotate.c"      },
                                { "ROTATECUBE", "rotatecube.c"  },
                                { "SCATTER",    "scatter.c"     },
                                { "SCONVL",     "sconvl.c"      },
                                { "SEGMENT",    "segment.c"     },
                                { "SIGMAP",     "sigmap.c"      },
                                { "SINESTAR",   "sinestar.c"    },
                                { "SINEWAVE",   "sinewave.c"    },
                                { "STATS",      "stats.c"       },
                                { "STRETCH",    "stretch.c"     },
                                { "SUBSAMPL",   "subsampl.c"    },
                                { "SWAP2",      "control.c"     },
                                { "SWAP4",      "control.c"     },
                                { "TEST",       ""              },
                                { "TFINVERT",   "stretch.c"     },
                                { "TFLINEAR",   "stretch.c"     },
                                { "TFLOG",      "stretch.c"     },
                                { "TFPLT",      "stretch.c"     },
                                { "TFPOWER",    "stretch.c"     },
                                { "TFQUANT",    "stretch.c"     },
                                { "TFROOT",     "stretch.c"     },
                                { "TFSAT",      "stretch.c"     },
                                { "TFSCALE",    "stretch.c"     },
                                { "TFSQUARE",   "stretch.c"     },
                                { "TFTABLE",    "stretch.c"     },
                                { "TFTHRESH",   "stretch.c"     },
                                { "TIFF2IMG",   "tiff2img.c"    },
                                { "TIMING",     "control.c"     },
                                { "TRNSFORM",   "trnsform.c"    },
                                { "UNPACK",     "control.c"     },
                                { "VMOSAIC",    "vmosaic.c"     },
                                { "VSTRETCH",   "vstretch.c"    },
                                { "WINDOW",     "window.c"      },
                                { "WTFCAVG",    "window.c"      },
                                { "WTFDIVER",   "window.c"      },
                                { "WTFMAJ",     "window.c"      },
                                { "WTFMAX",     "window.c"      },
                                { "WTFMIN",     "window.c"      },
                                { "WTFVAR",     "window.c"      } };

typedef struct _list {                  /* Data structure for tracking images */
    IMAGE        *image;
    struct _list *next;
} list;

short ABORT;                            /* Flag */

static short i, w, e;                   /* Message counts */

static short top;                       /* Number of functions on the stack */

static short stack[T_END];              /* Stack of function calls */

static long calls[T_END];               /* Number of calls per function */

static long actms[T_END];               /* Accumulated times per function */

static FILE *sys;                       /* Pointer to system log-file */

static list *img;                       /* List of allocated images */

#ifdef SADIE_LIB

#if HAVE_CONFIG_H
static const char version_string[] = PACKAGE_STRING;
#else
static const char version_string[] = "libSADIE 5";
#endif /* !HAVE_CONFIG_H */

uint32_t nlev;                          /* Global variables used by SADIE */
uint32_t csize;
double weight;
double power;
double *count;
PIXEL gain;
PIXEL bias;
PIXEL gmin;
PIXEL gmax;
PIXEL thresh;
PIXEL gbrk[2][4];
PIXEL *table;

void *app_data;                         /* Opaque application-specific data pointer */

/* Callback for tidying up the application-specific data */
static app_data_destructor_t app_data_destructor;

/* Callback table, one entry for each message severity level */
static app_messenger_t app_message[SAD_NLEVELS];

/* Progress meter callback function pointers */
app_progmeter_creator_t app_progmeter_create;
app_progmeter_updator_t app_progmeter_update;
app_progmeter_destructor_t app_progmeter_destroy;


/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This registers a function provided by the application using the SADIE    */
/*   library to handle messages with the specified severity level, which      */
/*   should correspond to one of the values defined for the message_level     */
/*   enum.  It returns zero on success, an error code on errors.              */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
int sad_register_message_callback (
int level,                             /*  I  Severity level for the message. */
app_messenger_t thecallback            /*  I  Function handling this level.   */
/*----------------------------------------------------------------------------*/
) {
    if (level<SAD_ERROR || level>=SAD_NLEVELS || !thecallback) return -1;
    app_message[level] = thecallback;
    return 0;
}

/* Macro to hide the messy details of the message callbacks */
#define APP_MESSAGE(lev,opt,txt) do { \
    if (app_message[lev]) \
      (*app_message[lev])((opt),(txt),app_data); \
  } while (0)

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This registers a function provided by the application using the SADIE    */
/*   library to create a progress meter, returning zero or an error code.     */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
int sad_register_creator_callback (
app_progmeter_creator_t thecallback  /*  I  Progress meter creation function. */
/*----------------------------------------------------------------------------*/
) {
    if (thecallback == NULL) return -1;
    app_progmeter_create = thecallback;
    return 0;
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This registers a function provided by the application using the SADIE    */
/*   library to update a progress meter, returning zero or an error code.     */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
int sad_register_updator_callback (
app_progmeter_updator_t thecallback  /*  I  Progress meter updating function. */
/*----------------------------------------------------------------------------*/
) {
    if (thecallback == NULL) return -1;
    app_progmeter_update = thecallback;
    return 0;
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This registers a function provided by the application using the SADIE    */
/*   library to destroy a progress meter, returning zero or an error code.    */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
int sad_register_destructor_callback (
app_progmeter_destructor_t thecallback     /*  I  Meter destruction function. */
/*----------------------------------------------------------------------------*/
) {
    if (thecallback == NULL) return -1;
    app_progmeter_destroy = thecallback;
    return 0;
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This registers a function provided by the application using the SADIE    */
/*   library to destroy the application's private data structure.             */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
int sad_register_data_destructor (
app_data_destructor_t thecallback /*  I  Private application data destructor. */
/*----------------------------------------------------------------------------*/
) {
    if (thecallback == NULL) return -1;
    app_data_destructor = thecallback;
    return 0;
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   All the application callbacks get passed a pointer to an optional opaque */
/*   data structure holding their private data, which the application can     */
/*   initialize here.  Non-zero return values are error codes.                */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
int sad_add_app_data (
void * thedata           /*  I  Opaque application-specific data pointer.     */
/*----------------------------------------------------------------------------*/
) {
    if (thedata == NULL || app_data != NULL) return -1;
    app_data = thedata;
    return 0;
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This invokes the application's private data destructor callback and      */
/*   clears the data from the SADIE library.                                  */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
int sad_remove_app_data (
void
/*----------------------------------------------------------------------------*/
) { int err=0;

    if (app_data != NULL && app_data_destructor != NULL) {
        err = (*app_data_destructor)(app_data);
    }
    if (!err) app_data = NULL;
    return err;
}


/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2004 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   Return the string giving the version of the SADIE library.               */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
const char * sad_version_string (
void
/*----------------------------------------------------------------------------*/
) {
  return version_string;
}

#endif /* defined SADIE_LIB */


/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This function initializes a SADIE program and must be called before      */
/*   any other SADIE function. If desired, global system variables must       */
/*   be set before this function is called.                                   */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
char *SLOG = NULL;      /*  I   Name of the system log-file.                  */
char *Environment = " " LOCALE "\x00" " " SYSTEM "\x00";
short Application = APP_SADIE;
short AppVersion  = 5000;
short NAMES = OFF;      /*  I   Switch, giving amount of log-file output:     */
                        /*      ON    -   function names are listed.          */
                        /*      OFF   -   function names are suppressed.      */
short TIMES = OFF;      /*  I   Switch, giving status of timing facility:     */
                        /*      ON    -   timing enabled.                     */
                        /*      OFF   -   timing disabled.                    */
short LINES = OFF;      /*  I   Switch, giving status of progress indicator:  */
                        /*      ON    -   progress indicator enabled.         */
                        /*      OFF   -   progress indicator disabled.        */
void INIT (
void
/*----------------------------------------------------------------------------*/
) { char msg[SLEN], *s;
    time_t secs;

    ABORT = FALSE;
    i = w = e = 0;
    for (top=0; top<T_END; top++) {
        stack[top] = 0;
        calls[top] = 0;
        actms[top] = 0;
    }
    top = 0;
    sys = NULL;
    img = NULL;

#if defined SADIE_UNIX
    /* open log-file */
    if (SLOG == NULL  ||  (sys=fopen(SLOG,"w+")) == NULL) {
        sys = stdout;
    }
#endif

    if (TIMES) {
        TIMING(T_MAIN);
        TIMING(T_INIT);
    }

    if (NAMES) {
        MESSAGE('I',"INIT");
        MESSAGE('I',"");
    }
    for (s = Environment; *s != '\0'; s += strlen(s)+1) {
        MESSAGE('I',s);
    }
    MESSAGE('I',"");
    secs = time(NULL);
    sprintf(msg," %.*s",strlen(ctime(&secs))-1,ctime(&secs));
    MESSAGE('I',msg);

    the_end:
    if (TIMES) TIMING(T_EXIT);
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This function terminates a SADIE program.                                */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void FINI (
void
/*----------------------------------------------------------------------------*/
) {
#if defined SADIE_UNIX
    char msg[SLEN];
#endif

    if (TIMES) TIMING(T_FINI);
    if (NAMES) {
        MESSAGE('I',"");
        MESSAGE('I',"FINI");
    }

    /* release all remaining images */
    while (img) RELMEM(img->image);

#if defined SADIE_UNIX
    /* output termination status */
    if (e || w) {
        sprintf(msg," SADIE terminated with %d warning(s) and %d error(s).",w,e);
    } else {
        sprintf(msg," SADIE completed successfully.");
    }
    MESSAGE('I',"");
    MESSAGE('I',msg);
#endif

    the_end:
    if (TIMES) {
        TIMING(T_EXIT);
        TIMING(T_EXIT);
    }

#if defined SADIE_UNIX
    if (sys != NULL  &&  sys != stdout) {
        fclose(sys);
    }
#endif
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function handles the output for all SADIE functions,      */
/*   with the exception of image display.                                     */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void MESSAGE (
char option,    /*  I   Switch, indicating the type of output:                */
                /*      'E'   -   Error.                                      */
                /*      'W'   -   Warning.                                    */
                /*      'I'   -   Informational message.                      */
                /*      'P'   -   Picture.                                    */
char *msg       /*  I   Pointer to an array[*] of characters, containing      */
                /*      one line of output (without terminating '\n').        */
/*----------------------------------------------------------------------------*/
) {
#if defined SADIE_MACOS
    char *s;
    short item, type, old;
    Handle handle;
    Rect rect;
    Str255 pstr;
    GrafPtr port;
    TextListPtr t;
    static TextListPtr last=NULL;
#endif

    /* update error counts and output message */
    switch (option) {
    case 'E':
        e += 1;
#if defined SADIE_LIB
        APP_MESSAGE(SAD_ERROR,option,msg);
#elif defined SADIE_IPT
        msg += 1;
        BringUpDialog(kRsrcConstant+kError);
        GetDialogItem(gDialog,kTextItem,&type,&handle,&rect);
        c2pstrcpy(pstr,msg);
        SetDialogItemText(handle,pstr);
        do { ModalDialog(NULL,&item); } while (item != kOKButton);
        PutDownDialog(FALSE);
        msg -= 1;
#else
        fprintf(sys,"%c:   %s\n",option,msg);
#endif
        break;
    case 'W':
        w += 1;
#if defined SADIE_LIB
        APP_MESSAGE(SAD_WARNING,option,msg);
#elif defined SADIE_IPT
        msg += 1;
        BringUpDialog(kRsrcConstant+kWarning);
        GetDialogItem(gDialog,kTextItem,&type,&handle,&rect);
        c2pstrcpy(pstr,msg);
        SetDialogItemText(handle,pstr);
        do { ModalDialog(NULL,&item); } while (item != kOKButton);
        PutDownDialog(FALSE);
        msg -= 1;
#else
        fprintf(sys,"%c:   %s\n",option,msg);
#endif
        break;
    case 'I':
        i += 1;
#if defined SADIE_LIB
        APP_MESSAGE(SAD_INFO,option,msg);
#elif defined SADIE_IPT
        if ((t=(TextListPtr)NewPtr((Size)(sizeof(TextListRec)))) == NULL  ||  (s=(char *)NewPtr((Size)((strlen(msg)+1)*sizeof(char)))) == NULL) {
            MESSAGE('E'," Memory request failed  -  can't update Session Log window.");
            goto the_end;
        }
        gSessionLog->image->nlin = i;
        gSessionLog->image->npix = max(gSessionLog->image->npix,strlen(msg)+2);
        if (last == NULL) {
            last = gSessionLog->text = t;
        } else {
            last = last->next = t;
        }
        last->type = TEXT;
        last->base = i;
        last->text = s;
        c2pstrcpy((StringPtr)last->text,msg);
        last->next = NULL;
        GetPort(&port);
        SetPortWindowPort(gSessionLog->window);
        GetWindowPortBounds(gSessionLog->window,&rect);
        SetControlMaximum(gSessionLog->scrollV,max(0,gSessionLog->image->nlin-(rect.bottom-kScrollSize+1-rect.top)/gHeight));
        SetControlMaximum(gSessionLog->scrollH,max(0,gSessionLog->image->npix-(rect.right-kScrollSize+1-rect.left)/gWidth ));
        old = GetControlValue(gSessionLog->scrollV);
        SetControlValue(gSessionLog->scrollV,GetControlMaximum(gSessionLog->scrollV));
        ScrollWindow(gSessionLog,0,old-GetControlMaximum(gSessionLog->scrollV));
        SetPort(port);
#else
        fprintf(sys,"%c:   %s\n",option,msg);
#endif
        break;
#if defined SADIE_IPT
    case 'P':
        if ((t=(TextListPtr)NewPtr((Size)(sizeof(TextListRec)))) == NULL) {
            MESSAGE('E'," Memory request failed  -  can't update Session Log window.");
            goto the_end;
        }
        i += (*(PicHandle)msg)->picFrame.bottom/gHeight + ((*(PicHandle)msg)->picFrame.bottom%gHeight == 0  ?  0 : 1);
        gSessionLog->image->nlin = i;
        gSessionLog->image->npix = max(gSessionLog->image->npix,(*(PicHandle)msg)->picFrame.right/gWidth+((*(PicHandle)msg)->picFrame.right%gWidth == 0  ?  1 : 2)+2);
        if (last == NULL) {
            last = gSessionLog->text = t;
        } else {
            last = last->next = t;
        }
        last->type = COLOR;
        last->base = i;
        last->text = msg;
        last->next = NULL;
        GetPort(&port);
        SetPortWindowPort(gSessionLog->window);
        GetWindowPortBounds(gSessionLog->window,&rect);
        SetControlMaximum(gSessionLog->scrollV,max(0,gSessionLog->image->nlin-(rect.bottom-kScrollSize+1-rect.top)/gHeight));
        SetControlMaximum(gSessionLog->scrollH,max(0,gSessionLog->image->npix-(rect.right-kScrollSize+1-rect.left)/gWidth ));
        old = GetControlValue(gSessionLog->scrollV);
        SetControlValue(gSessionLog->scrollV,GetControlMaximum(gSessionLog->scrollV));
        ScrollWindow(gSessionLog,0,old-GetControlMaximum(gSessionLog->scrollV));
        SetPort(port);
        break;
#endif
#if defined SADIE_LIB
    default:
        APP_MESSAGE(SAD_DEFAULT,option,msg);
        break;
#endif
    }

    the_end:;
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function provides a timing facility for SADIE.            */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void TIMING (
T_TIME function  /*  I   Switch, indicating the calling function.             */
/*----------------------------------------------------------------------------*/
) { register short i;
    char msg[SLEN];
    time_t cur_time;

    /* update time-keeping */
    cur_time = time(NULL);
    actms[stack[top]] += (long)cur_time;
    stack[function ? calls[function]++,++top : top--] = (short)function;
    actms[stack[top]] -= (long)cur_time;

    /* output statistics */
    if (top == 0  &&  TIMES == ON) {
        TIMES = OFF;
        if (NAMES) {
            MESSAGE('I',"");
            MESSAGE('I',"TIMING");
        }
        MESSAGE('I',"");
        MESSAGE('I'," Function    # of calls      Elapsed time    Time in %");
        MESSAGE('I',"");
        for (i=1; i<T_END; i++) {
            if (calls[i]) {
                sprintf(msg," %-10s%12ld        %02ld:%02ld:%02ld%13.1f",functions[i][0],calls[i],actms[i]/3600L,actms[i]/60L-60L*(actms[i]/3600L),actms[i]%60L,(actms[0] ? -(double)actms[i]/(double)actms[0]*100.0:0.0));
                MESSAGE('I',msg);
            }
        }
    }
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1989 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function provides a progress indicator for SADIE.         */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
short PROGRESS (
double pct      /*  I   Percentage of work completed (0.0 <= pct <= 1.0).     */
/*----------------------------------------------------------------------------*/
) {
#if defined SADIE_IPT
/*
short item;
*/
#endif

    if (TIMES) TIMING(T_PROGRESS);

    /* output percentage */
#ifndef SADIE_IPT
    fprintf(stderr,"%3d%%\b\b\b\b",(int)(100.0*pct));
    fflush(stderr);
#else
/*
    ModalDialog(gMovableModalUPP,&item);
    if (item == kCancelButton) {
        ABORT = TRUE;
        return(FALSE);
    }
    gDialogItem[kProgressBar] = (long)(&pct);
    ProgressBar(gDialog,kProgressBar);
*/
#endif

    the_end:
    if (TIMES) TIMING(T_EXIT);
    return(TRUE);
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-Programmer Information-----------------------------------------------------*/
/*                                                                            */
/*   The number and size of images that may be allocated from a program is    */
/*   system-dependent. However, this code will work on any system without     */
/*   modifications.                                                           */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function allocates memory for a new image, and            */
/*   initializes its data structure.                                          */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void GETMEM (
uint32_t nbnd,  /*  I   Number of bands.                                      */
uint32_t nlin,  /*  I   Number of lines.                                      */
uint32_t npix,  /*  I   Number of pixels/line.                                */
IMAGE **out     /*  O   Address of a pointer to the image being allocated.    */
/*----------------------------------------------------------------------------*/
) { register uint32_t i, j;
    uint64_t total;
    BYTE *ptr;
    list *link;

    if (TIMES) TIMING(T_GETMEM);

    /* allocate space for image data structure, image data and list entry */
    total = ((uint64_t)sizeof(IMAGE) + (uint64_t)nbnd*(uint64_t)sizeof(PIXEL **) + (uint64_t)nbnd*(uint64_t)nlin*(uint64_t)sizeof(PIXEL *) + (uint64_t)nbnd*(uint64_t)nlin*(uint64_t)npix*(uint64_t)sizeof(PIXEL) + (uint64_t)sizeof(list)) * (uint64_t)sizeof(BYTE);
    if (total > (uint64_t)SIZE_MAX  ||  (*out=(IMAGE *)malloc((size_t)total)) == NULL) {
        MESSAGE('E'," Memory request failed.");
        *out = NULL;
        goto the_end;
    }

    /* assign default values */
    (*out)->fileformat  = FILE_FORMAT;
    (*out)->fileversion = FILE_VERSION;
    (*out)->application = Application;
    (*out)->appversion  = AppVersion;
    (*out)->dataformat  = EXTDATA_IEEE_F32;
    (*out)->datapacking = BE_BITPACKED;
    (*out)->datarotation[0] = PIXEL_DIMENSION    | VALUES_NORMAL;
    (*out)->datarotation[1] = LINE_DIMENSION     | VALUES_NORMAL;
    (*out)->datarotation[2] = BAND_DIMENSION     | VALUES_NORMAL;
    (*out)->datarotation[3] = INTERVAL_DIMENSION | VALUES_NORMAL;
    (*out)->npix = npix;
    (*out)->nlin = nlin;
    (*out)->nbnd = nbnd;
    (*out)->ntvl = 1;
    (*out)->nbit = SBIT;
/*  (*out)->gmin = undefined;  */
/*  (*out)->gmax = undefined;  */
    for (i=0; i<TLEN; i++) {
        (*out)->text[i] = '\0'; 
    }

    /* initialize pointers */
    ptr = (BYTE *)(*out);
    (*out)->data = (PIXEL ***)(ptr + (uint64_t)sizeof(IMAGE));
    for (i=0; i<nbnd; i++) {
        (*out)->data[i] = (PIXEL **)(ptr + (uint64_t)sizeof(IMAGE) + (uint64_t)nbnd*(uint64_t)sizeof(PIXEL **) + (uint64_t)i*(uint64_t)nlin*(uint64_t)sizeof(PIXEL *));
        for (j=0; j<nlin; j++) {
            (*out)->data[i][j] = (PIXEL *)(ptr + (uint64_t)sizeof(IMAGE) + (uint64_t)nbnd*(uint64_t)sizeof(PIXEL **) + (uint64_t)nbnd*(uint64_t)nlin*(uint64_t)sizeof(PIXEL *) + ((uint64_t)j*(uint64_t)nbnd+(uint64_t)i)*(uint64_t)npix*(uint64_t)sizeof(PIXEL));
        }
    }

    /* put new entry on the list */
    link        = (list *)(ptr + (uint64_t)total - (uint64_t)sizeof(list));
    link->image = *out;
    link->next  = img;
    img         = link;

    the_end:
    if (TIMES) TIMING(T_EXIT);
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This function releases an image to free memory space.                    */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void RELIMG (
IMAGE **out     /* I/O  Address of the pointer to the image to be released.   */
/*----------------------------------------------------------------------------*/
) {
    if (TIMES) TIMING(T_RELIMG);
    if (NAMES) {
        MESSAGE('I',"");
        MESSAGE('I',"RELIMG");
    }

    /* check input */
    if (!CHECKIMG(*out)) {
        MESSAGE('E'," Can't identify image.");
        goto the_end;
    }

    /* release image */
    RELMEM(*out);
    *out = NULL;

    the_end:
    if (TIMES) TIMING(T_EXIT);
}
 
/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function releases an image and frees its data structure.  */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void RELMEM (
IMAGE *in       /*  I   Pointer to the image to be released.                  */
/*----------------------------------------------------------------------------*/
) { register list *ptr;

    if (TIMES) TIMING(T_RELMEM);

    /* take image off the list */
    if (img->image == in) {
        img = img->next;
    } else {
        for (ptr=img; ptr->next->image!=in; ptr=ptr->next) {
            continue;
        }
        ptr->next = ptr->next->next;
    }

    /* free allocated space */
    free(in);
    in = NULL;

    the_end:
    if (TIMES) TIMING(T_EXIT);
}
 
/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function determines whether or not an IMAGE pointer       */
/*   points to an image that was properly created by SADIE.                   */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
short CHECKIMG (
IMAGE *in       /*  I   Pointer to the image to be checked.                   */
/*----------------------------------------------------------------------------*/
) { list *ptr;

    if (TIMES) TIMING(T_CHECKIMG);

    /* check to see if image is on the list */
    for (ptr=img; ptr!=NULL && ptr->image!=in; ptr=ptr->next) {
        continue;
    }

    the_end:
    if (TIMES) TIMING(T_EXIT);
    return(ptr!=NULL);
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function finds the maximum and minimum graylevels         */
/*   in an image.                                                             */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void RANGE (
IMAGE *in       /*  I   Pointer to the input image.                           */
/*----------------------------------------------------------------------------*/
) { register PIXEL *p1, *p2, *p3, *gmin, *gmax;

    if (TIMES) TIMING(T_RANGE);

    /* find minimum and maximum */
    if (((uint64_t)in->nbnd*(uint64_t)in->nlin*(uint64_t)in->npix)%((uint64_t)2) == 0) {
        p1 = &in->data[0][0][0];
        p2 = &in->data[0][0][1];
    } else {
        p1 = &in->data[0][0][1];
        p2 = &in->data[0][0][2];
    }
    p3 = &(in->data[in->nbnd-1][in->nlin-1][in->npix-1]);
    for (gmin=gmax=(&in->data[0][0][0]); p1<p3; p1+=2,p2+=2) {
        if (*p1 < *p2) {
            if (*p1 < *gmin) gmin = p1;
            if (*p2 > *gmax) gmax = p2;
        } else {
            if (*p2 < *gmin) gmin = p2;
            if (*p1 > *gmax) gmax = p1;
        }
    }
    in->gmin = *gmin;
    in->gmax = *gmax;

    if (TIMES) TIMING(T_EXIT);
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1995 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function swaps the bytes in a 2-byte word.                */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void SWAP2 (
BYTE *cptr           /*  I  Pointer to the first byte of a 2-byte word.       */
/*----------------------------------------------------------------------------*/
) { BYTE b;

    if (TIMES) TIMING(T_SWAP2);

    b = cptr[0];
    cptr[0] = cptr[1];
    cptr[1] = b;

    the_end:
    if (TIMES) TIMING(T_EXIT);
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 2003 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function swaps the bytes in a 4-byte word.                */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void SWAP4 (
BYTE *cptr           /*  I  Pointer to the first byte of a 4-byte word.       */
/*----------------------------------------------------------------------------*/
) { BYTE b;

    if (TIMES) TIMING(T_SWAP4);

    b = cptr[0];
    cptr[0] = cptr[3];
    cptr[3] = b;
    b = cptr[1];
    cptr[1] = cptr[2];
    cptr[2] = b;

    the_end:
    if (TIMES) TIMING(T_EXIT);
}
 
/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1989 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function packs an array of pixels from PIXEL              */
/*   representation to "nbit" bits per pixel.                                 */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void PACK (
uint32_t nbit,  /*  I   Number of bits/pixel.                                 */
uint64_t npix,  /*  I   Number of pixels in the array.                        */
PIXEL *line     /* I/O  Pointer to an array[npix] of pixels.                  */
/*----------------------------------------------------------------------------*/
) { register BYTE *pckd=(BYTE *)line;
    register int64_t i, j, k, l, m;
    unsigned long lpix;

    if (TIMES) TIMING(T_PACK);

    /* pack to nbit bits per pixel, in place */
    for (i=0,j=(-1),l=m=SBPB; i<npix; i++) {
        for (lpix=(unsigned long)line[i],k=nbit; k>0; m=k,k-=l) {
            l = m < l ? l-m : ((pckd[++j]=0),SBPB);
            pckd[j] |= lpix  <<  SBPB*sizeof(lpix) - k  >>  SBPB*sizeof(lpix) - l;
        }
    }

    the_end:
    if (TIMES) TIMING(T_EXIT);
}
 
/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1989 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function unpacks an array of pixels from "nbit"           */
/*   bits per pixel to PIXEL representation.                                  */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void UNPACK (
uint32_t nbit,  /*  I   Number of bits/pixel.                                 */
uint64_t npix,  /*  I   Number of pixels in the array.                        */
PIXEL *line     /* I/O  Pointer to an array[npix] of pixels.                  */
/*----------------------------------------------------------------------------*/
) { register BYTE *pckd=(BYTE *)line;
    int64_t i, j, k, l, m;
    unsigned long lpix, mask=(unsigned long)~0 >> sizeof(lpix)*SBPB-nbit;

    if (TIMES) TIMING(T_UNPACK);

    /* unpack from nbit bits per pixel, in place */
    for (i=npix-1,j=(long)ceil((double)(npix*nbit)/(double)SBPB)-1,l=(npix*nbit)%SBPB?(npix*nbit)%SBPB:SBPB,m=0; i>=0; line[i--]=(PIXEL)(lpix&mask)) {
        for (lpix=0,k=nbit; k>0; m=k,k-=l) {
            l = m < l ? l-m : (--j,SBPB);
            lpix |= (unsigned long)pckd[j] >> SBPB-l << nbit-k;
        }
    }

    the_end:
    if (TIMES) TIMING(T_EXIT);
}

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This low-level function extracts documentation from SADIE source code.   */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void HELP (
T_TIME function, /*  I   Switch, indicating the desired function.             */
char *options    /*  I   is any combination of the following (as a string):   */
                 /*      'B'     Background Information will be listed.       */
                 /*      'C'     Copyright Information will be listed.        */
                 /*      'G'     General Information will be listed.          */
                 /*      'I'     Interface Information will be listed.        */
                 /*      'P'     Programmer Information will be listed.       */
/*----------------------------------------------------------------------------*/
) { register short i, j, k;
    char msg[SLEN], fname[SLEN];
    long last[SLEN], temp;
    FILE *fp = NULL;

    if (TIMES) TIMING(T_HELP);

    /* check input */
    if (T_EXIT > function  ||  strlen(functions[function][1]) == 0  ||  function > T_END) {
        MESSAGE('E'," Can't find documentation.");
        goto the_end;
    }

    /* open documentation file */
    sprintf(fname,"%s%s",DIR,functions[function][1]);
    if (!(fp=fopen(fname,"r"))) {
        sprintf(msg," Can't open file %s.",fname);
        MESSAGE('E',msg);
        goto the_end;
    }

    /* search file for requested documentation */
    for (i=0; i<strlen(options); i++) {
        last[i] = -1L;
    }
    for (i=1; fgets(msg,SLEN,fp); i++) {
        if (strncmp(msg,BEGIN,strlen(BEGIN)) == 0) {
            for (j=0; j<strlen(options); j++) {
                if (msg[CODE] == options[j]) {
                    if (last[j] > -1L) {
                        for (k=0; k<strlen(options); k++) {
                            last[k] = -1L;
                        }
                    }
                    last[j] = ftell(fp) - (long)strlen(msg);
                }
            }
        }
        for (j=0; j<=strlen(msg)-strlen(functions[function][0]); j++) {
            if (strncmp(msg+j,functions[function][0],strlen(functions[function][0])) == 0  &&  msg[j+strlen(functions[function][0])] == ' ') goto sort;
        }
    }

    sort: /* output */
    for (i=0; i<strlen(options); i++) {
        for (j=i+1; j<strlen(options); j++) {
            if (last[i] > last[j]) {
                temp = last[i];
                last[i] = last[j];
                last[j] = temp;
            }
        }
    }

    /* output documentation */
    for (i=0; i<strlen(options); i++) {
        if (last[i] > -1L) {
            fseek(fp,last[i],0);
            fgets(msg,SLEN,fp);
            do {
                MESSAGE(' ',msg);
                fgets(msg,SLEN,fp);
            } while (strncmp(msg,END,strlen(END)));
            MESSAGE(' ',msg);
        }
    }

    /* close documentation file */
    if (fclose(fp)) {
        sprintf(msg," Can't close file %s.",fname);
        MESSAGE('W',msg);
    }

    the_end:
    if (TIMES) TIMING(T_EXIT);
}
