#ifdef HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include        "sadie.h"

/*-Copyright Information------------------------------------------------------*/
/* Copyright (c) 1988 by the University of Arizona Digital Image Analysis Lab */
/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This function outputs the information from an image's data structure.    */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void IMGINFO (
IMAGE *in       /*  I   Pointer to the image.                                 */
/*----------------------------------------------------------------------------*/
) { char msg[SLEN];

    if (TIMES) TIMING(T_IMGINFO);
    if (NAMES) {
        MESSAGE('I',"");
        MESSAGE('I',"IMGINFO");
    }

    /* check input */
    if (!CHECKIMG(in)) {
        MESSAGE('E'," Can't identify image.");
        goto the_end;
    }

    if (NAMES) {
        MESSAGE('I',"");
        sprintf(msg," Input image:                                %s",in->text);
        MESSAGE('I',msg);
        MESSAGE('I'," ...............");
    }

    /* update and output information on image */
    RANGE(in);
    MESSAGE('I',"");
    sprintf(msg," Number of bands, lines, pixels:             %lu, %lu, %lu",in->nbnd,in->nlin,in->npix);
    MESSAGE('I',msg);
    sprintf(msg," Number of bits/pixel/band:                  %lu",in->nbit);
    MESSAGE('I',msg);
    sprintf(msg," Graylevel minimum, maximum:                 %10.4e, %10.4e",in->gmin,in->gmax);
    MESSAGE('I',msg);

    the_end:
    if (TIMES) TIMING(T_EXIT);
}
